   LIBNAME Macrolib "C:\Users\GlassR\Desktop\samples\Macrolib";
   OPTIONS MSTORED SASMSTORE=Macrolib ;

   ********************************************************************************************;
   ** save compiled autodoc macro;
   ** change the libname doc statement to point to the folder where the documentation is stored;
   ** When the macro s called, docfile provides the documentation log's path and file name     :
   ********************************************************************************************;

   %MACRO autodoc(docfile)/ STORE SOURCE DES="Creates program log";

   LIBNAME doc 'S:\Projects\Sample'; 

   %let LENGTHS = program_name $ 100
			run_date $ 9 
			run_time $ 8
		   	run_by $ 32 
           		purpose $ 500  
			input_files $500
		      output_files $500;

   * collect run information for this execution of the program;

   DATA userline;
		LENGTH &lengths.;

		run_by="&sysuserid";
		run_date="&sysdate";
		run_time="&systime";
		purpose="&purpose";
		input_files=" ";
		output_files=" ";

		path_program = "%sysfunc(getoption(sysin))";
		word_n = countc(path_program,"\.");
		program_name = scan(path_program,word_n,"\." );

		DROP word_n path_program;
   RUN;


   PROC PRINT data=userline noobs;
		TITLE1 Documentation line saved for this program;
   RUN;

   * assuming manual edits have been made to the spreadsheet;
   * read current doc excel file into SAS;

   PROC IMPORT 
		DBMS = excel 
		out = backupdocA
    	datafile = "&docfile."; 
   RUN;

   DATA backupdoc;
    	LENGTH &lengths.;

		SET backupdocA;
   RUN;

   * append the new information *;

   PROC APPEND data=userline base=backupdoc force;
   RUN;

   * re-save the updated backupdoc SAS file;

   DATA doc.backupdoc;
	 	SET backupdoc;
   RUN;

   * re-save the excel file;

   PROC EXPORT data= doc.backupdoc 
		outfile= "&docfile." 
     	DBMS=EXCEL 
		label replace;
     	sheet="program log"; 
   RUN;


   %MEND;

   RUN;
