OPTIONS PS=55 LS=175 ERRORABEND NOFMTERR ERRORS=1 MPRINT SYMBOLGEN NOCENTER NODATE NONUMBER
;

TITLE1 "SGF 2016 Session 8300";
FOOTNOTE1 "%SYSFUNC(GETOPTION(SYSIN)) - &SYSDATE - &SYSTIME - run by &SYSUSERID";
RUN;

TITLE2 "Heart";
RUN;

LIBNAME dd '.';

FILENAME odsout ".";
FILENAME out1 ".\heart_labelstm.txt"; /* for labels */
FILENAME out2 ".\heart_formatstm.txt"; /* for format assignment */

LIBNAME library '.';
RUN;


/* set up some mini data sets with top and bottom lines */


DATA runlabel;
    LENGTH include_string $ 180;
    include_string="*** Label Statement for heart;";
    OUTPUT;
    include_string='LABEL';
    OUTPUT;
RUN;


DATA runformat;
    LENGTH include_string $ 180;
    include_string="*** Format Assignments for heart;";
    OUTPUT;
    include_string='FORMAT';
    OUTPUT;
RUN;


DATA runrun;
    LENGTH include_string $ 180;
    include_string=';';
RUN;



DATA temp1;
    LENGTH include_string $ 180;
    SET dd.heart_cb;

    label=COMPRESS(label,'"');

    qlabel=CATS('"',label,'"');
    include_string=CATX(' ',name,'=',qlabel);
RUN;

DATA templabel (KEEP=include_string);
    FILE out1 LRECL=180 PAD;
    LENGTH include_string $ 180;
    SET runlabel temp1 runrun;
    PUT include_string;
RUN;



DATA temp2;
    LENGTH include_string $ 180;
    SET dd.heart_cb (WHERE=(format NE ''));
    qformat=CATS(format,'.');
    include_string=CATX(' ',name,qformat);
RUN;

DATA tempfmt (KEEP=include_string);
    FILE out2 LRECL=180 PAD;
    LENGTH include_string $ 180;
    SET runformat temp2 runrun;
    PUT include_string;
RUN;





endsas;


